#include "choosetearset.h"

using namespace std;

/// simply choose the first minimum-length tearset
TearSet
choosetearset(const vector<TearSet> &ts, const System &sys){

	vector<TearSet>::const_iterator i, j;
	unsigned min_length=(*(ts.begin())).size(); 
	for(i=ts.begin(); i<ts.end(); ++i){
		if((*i).size() < min_length){
			min_length = (*i).size();
		}
	}

	// output the minimal tearsets
	for(i=ts.begin(); i<ts.end(); ++i){
		if((*i).size() == min_length){
			cerr << "Tearset: ";
			set<unsigned> tearset = *i;
			set<unsigned>::iterator j;
			for(j=tearset.begin(); j!=tearset.end(); ++j){
				cerr << sys.getVariableName(*j) << " ";
			}
			cerr << endl;
		}
	}
	for(i=ts.begin(); i<ts.end(); ++i){
		if((*i).size() == min_length){
			j = i;
		}
	}
	return *j;
}

