/*

nla-ginac - Tarjan-blocking NLA solver with autodiff
Copyright (C) 2005  John Pye

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef COLEBROOK_H
#define COLEBROOK_H

#define MAX_COLEBROOK_ITER 20
#define COLEBROOK_TOL 1e-7

/**
	Returns friction factor, calculated such taht 1/sqrt(f) has moved by less than 1e-5 between iterations.
	This corresponds to a tolerance on f of about 1.04e-7 when f = 0.05.
*/
class Colebrook{
public:
	static double f_ReEd(const double &Re, const double &Ed);
};

#endif
