#include "cycle.h"

using namespace std;

bool
cycle::operator< (const cycle &b) const{
	cycle::const_iterator ai = begin();
	cycle::const_iterator bi;
	bool found=false;
	unsigned nb=0, na=0;
	unsigned bmin;
	for(bi=b.begin(), bmin=*bi; bi!=b.end(); ++bi, ++nb){
		if(bmin < *bi)bmin=*bi;
		if(*bi==*ai){
			found=true;
			break;
		}
	}
	if(!found){
		// if a's lowest element is less then b's lowest element then a < b:
		unsigned amin;
		for(ai=begin(), amin=*ai; ai!=end(); ++ai, ++na){
			if(amin<*ai)amin=*ai;
		}
		if(amin < bmin){
			
			return true;
		}
		return false;
	}
	
	do{
		++ai; ++bi;
		if(bi==b.end())bi=b.begin();
		if(ai==end() || *ai > *bi) break;
		if(*ai==*bi) continue;
		if(*ai < *bi) return true;
	}while(1);
	
	return false; // the cycles are equal;
}
	
bool 
cycle::operator== (const cycle &b) const{
	
	cerr << "Checking for cycle equality" << endl;
	exit(1);
	//cerr << "a = " << *this << endl;
	//cerr << "b = " << b << endl;

	// start at first element of a
	list<unsigned>::const_iterator ai = this->begin();
	list<unsigned>::const_iterator bi = b.begin();
	list<unsigned>::const_iterator bstart = b.end();
	bool found=false;
	unsigned nb=0;

	// first traverse b until we find an element which matches
	while(bi != b.end()){
		if(*ai == *bi){	
			// cerr << "a = " << *this << ", b = " << b<< ": Matching first element from 'a'" << endl;
			// we have found matching elements in the cycle (reuse the 'n' variable as a flag)
			bstart==bi;
			found=true;
			break;
		}
		++nb;
		++bi;
	}
	if(!found){
		// cerr << "a = " << *this << ", b = " << b<< ": No matching first element" << endl;
		return false;
	}else{
		cerr << "a.begin() = " << *(this->begin()) << ", bi = " << *(bi) << " ";
		// cerr<< "FIRST MATCH ";
	}

	unsigned na = 0;
	while(ai!=end()){
		// increment bi but return to the start once we move beyond the end.
		++bi; if(bi == b.end()) bi=b.begin();
		++ai; ++na;
		if(*ai!=*bi){
			cerr << "a = " << *this << ", b = " << b<< ": Subsequent element mismatch" << endl;
			return false;
		}
	}

	if(na==nb){
		cerr << "a = " << *this << ", b = " << b<< ": ***  MATCH *** " << endl;
		return true;
	}
	cerr << "a = " << *this << ", b = " << b<< ": Length mismatch" << endl;
	return false; // b is not the same length as a.

}

ostream& operator<< (ostream& os , const cycle & a) {
	// start with lowest number
	unsigned n = a.size();
	cycle::const_iterator i;
	cycle::const_iterator start;
	for(i=a.begin(), start=a.begin(); i!=a.end(); i++){
		if(*start > *i){
			start=i;
		}
	}
	os << "{";

	unsigned j;
	for(j=0, i=start; j < n; j++){
		if(i!=start) os << ", ";
		os << *i;
		++i; if(i==a.end())i=a.begin();
	}
	os << "}";
	return os;
}
