#ifndef CYCLE_H
#define CYCLE_H

#include <list>
#include <iostream>
#include <set>

/**
	Class that allows ordered lists to be compared as matching loops
	such that ABCD == DABC and AB == BA.
	All items must be present in the same order when when viewed as a loop.
*/

class cycle : public std::list<unsigned>{

private:

	typedef std::list<unsigned> Tlist;
	typedef std::list<unsigned>::iterator Tlistiterator;

public:

	bool operator<(const cycle &b) const;
	bool operator ==(const cycle &b) const;

    friend std::ostream& operator<< (std::ostream& ofs, const cycle &a);

};

class cycle_lt{
public:
	inline bool operator()(const cycle &a, const cycle &b){
		return a < b;
	}
};

std::ostream& operator<< (std::ostream& os , const cycle & a);

typedef std::set<cycle,cycle_lt> CycleSet;

#endif
