#ifndef MATBOOL_H
#define MATBOOL_H

/**
	Sparse Matrix of Booleans

	This is indended to reproduce the functionality of setup_ from the MC21A
	package, for compact storage of a sparse matrix of true/false values.

	This will be used to replace the FORTRAN_ARRAY(A,r,c,n) format currently
	used.

	NEEDS TO BE COMPATIBLE with MC21A for the moment; this can change later.
*/

typedef vector<unsigned> VecInt;
typedef VecInt::iterator VecIntIter;

class MatBool{

public:
	MatBool(const unsigned &nr, const unsigned &nc);
	MatBool(const SpMatBool &a);
	MatBool &operator=(const SpMatBool &a);

	~MatBool();

	inline const unsigned &rows() const{return nr};
	inline const unsigned &cols() const{return nc};

	bool & operator()(const unsigned &r, const unsigned &c);

private:
	unsigned nr;
	unsigned nc;
	VecInt icn;
	VecInt ip;
	VecInt lenr;

friend ostream &operator<<(const ostream &s, const MatBool &a);

};


#endif
