C
C
C SUBROUTINE MC13D
C http://www.netlib.org/toms/529
C
C THIS CODE IS ***NOT*** FOR COMMERICAL USE
C SEE LICENSE CONDITIONS AT 'TOMS' WEBSITE
C
C


C SETUP CONVERTS MATRIX A(I,J) TO REQUIRED SPARSITY-ORIENTED
C STORAGE FORMAT.
      SUBROUTINE SETUPMC13D(N, A, MM, IP, ICN, LICN, LENR)                   SET   10
      LOGICAL A(MM,MM)
      INTEGER IP(N), ICN(LICN), LENR(N)
      DO 10 I=1,N
        LENR(I) = 0
   10 CONTINUE
      IND = 1
      DO 30 I=1,N
        IP(I) = IND
        DO 20 J=1,N
          IF (.NOT.A(I,J)) GO TO 20
          LENR(I) = LENR(I) + 1
          ICN(IND) = J
          IND = IND + 1
   20   CONTINUE
   30 CONTINUE
      RETURN
      END


C                                                                       MC1   30
      SUBROUTINE MC13D(N, ICN, LICN, IP, LENR, IOR, IB, NUM, IW)        MC1   40
c
c description of parameters.
c input variables  .... N,ICN,LICN,IP,LENR.
c output variables  ior,ib,num.
C
c N   order of the matrix.
c ICN array containing the column indices of the non-zeros.  those
c     belonging to a single row must be contiguous but the ordering
c     of column indices within each row is unimportant and wasted
c     space between rows is permitted.
c LICN  length of array icn.
c IP  ip(i), i=1,2,...n, is the position in array icn of the first
c     column index of a non-zero in row i.
c LENR  lenr(i) is the number of non-zeros in row i, i=1,2,...n.
c IOR  ior(i) gives the position in the original ordering of the row
c     or column which is in position i in the permuted form, i=1,2,..n.
c IB  ib(i) is the row number in the permuted matrix of the beginning
c     of block i, i=1,2,...num.
c NUM number of blocks found.
c iw  work array .. see later comments.
C
      INTEGER IP(N)
      INTEGER ICN(LICN), LENR(N), IOR(N), IB(N), IW(N,3)
      CALL MC13E(N, ICN, LICN, IP, LENR, IOR, IB, NUM, IW(1,1),
     *  IW(1,2), IW(1,3))
      RETURN
      END


      SUBROUTINE MC13E(N, ICN, LICN, IP, LENR, ARP, IB, NUM, LOWL,      MC1   10
     *  NUMB, PREV)
      INTEGER STP, DUMMY
      INTEGER IP(N)
c
c ARP(i) is one less than the number of unsearched edges leaving
c     node i.  at the end of the algorithm it is set to a
c     permutation which puts the matrix in block lower
c     triangular form.
c IB(i) is the position in the ordering of the start of the ith
c     block.  IB(n+1-i) holds the node number of the ith node
c     on the stack.
c LOWL(i) is the smallest stack position of any node to which a path
c     from node i has been found.  it is set to n+1 when node i
c     is removed from the stack.
c NUMB(i) is the position of node i in the stack if it is on
c     it, is the permuted order of node i for those nodes
c     whose final position has been found and is otherwise zero.
c PREV(i) is the node at the end of the path when node i was
c     placed on the stack.
      INTEGER ICN(LICN), LENR(N), ARP(N), IB(N), LOWL(N), NUMB(N),
     *  PREV(N)
C
C
C   ICNT IS THE NUMBER OF NODES WHOSE POSITIONS IN FINAL ORDERING HAVE
C     BEEN FOUND.
      ICNT = 0
C NUM IS THE NUMBER OF BLOCKS THAT HAVE BEEN FOUND.
      NUM = 0
      NNM1 = N + N - 1
C
C INITIALIZATION OF ARRAYS.
      DO 10 J=1,N
        NUMB(J) = 0
        ARP(J) = LENR(J) - 1
   10 CONTINUE
C
C
      DO 90 ISN=1,N
C LOOK FOR A STARTING NODE
        IF (NUMB(ISN).NE.0) GO TO 90
        IV = ISN
C IST IS THE NUMBER OF NODES ON THE STACK ... IT IS THE STACK POINTER.
        IST = 1
C PUT NODE IV AT BEGINNING OF STACK.
        LOWL(IV) = 1
        NUMB(IV) = 1
        IB(N) = IV
C
C THE BODY OF THIS LOOP PUTS A NEW NODE ON THE STACK OR BACKTRACKS.
        DO 80 DUMMY=1,NNM1
          I1 = ARP(IV)
C HAVE ALL EDGES LEAVING NODE IV BEEN SEARCHED.
          IF (I1.LT.0) GO TO 30
          I2 = IP(IV) + LENR(IV) - 1
          I1 = I2 - I1
C
C LOOK AT EDGES LEAVING NODE IV UNTIL ONE ENTERS A NEW NODE OR
C     ALL EDGES ARE EXHAUSTED.
          DO 20 II=I1,I2
            IW = ICN(II)
C HAS NODE IW BEEN ON STACK ALREADY.
            IF (NUMB(IW).EQ.0) GO TO 70
C UPDATE VALUE OF LOWL(IV) IF NECESSARY.
            IF (LOWL(IW).LT.LOWL(IV)) LOWL(IV) = LOWL(IW)
   20     CONTINUE
C
C THERE ARE NO MORE EDGES LEAVING NODE IV.
          ARP(IV) = -1
C IS NODE IV THE ROOT OF A BLOCK.
   30     IF (LOWL(IV).LT.NUMB(IV)) GO TO 60
C
C ORDER NODES IN A BLOCK.
          NUM = NUM + 1
          IST1 = N + 1 - IST
          LCNT = ICNT + 1
C PEEL BLOCK OFF THE TOP OF THE STACK STARTING AT THE TOP AND
C     WORKING DOWN TO THE ROOT OF THE BLOCK.
          DO 40 STP=IST1,N
            IW = IB(STP)
            LOWL(IW) = N + 1
            ICNT = ICNT + 1
            NUMB(IW) = ICNT
            IF (IW.EQ.IV) GO TO 50
   40     CONTINUE
   50     IST = N - STP
          IB(NUM) = LCNT
C ARE THERE ANY NODES LEFT ON THE STACK.
          IF (IST.NE.0) GO TO 60
C HAVE ALL THE NODES BEEN ORDERED.
          IF (ICNT.LT.N) GO TO 90
          GO TO 100
C
C BACKTRACK TO PREVIOUS NODE ON PATH.
   60     IW = IV
          IV = PREV(IV)
C UPDATE VALUE OF LOWL(IV) IF NECESSARY.
          IF (LOWL(IW).LT.LOWL(IV)) LOWL(IV) = LOWL(IW)
          GO TO 80
C
C PUT NEW NODE ON THE STACK.
   70     ARP(IV) = I2 - II - 1
          PREV(IW) = IV
          IV = IW
          IST = IST + 1
          LOWL(IV) = IST
          NUMB(IV) = IST
          K = N + 1 - IST
          IB(K) = IV
   80   CONTINUE
C
   90 CONTINUE
C
C
C PUT PERMUTATION IN THE REQUIRED FORM.
  100 DO 110 I=1,N
        II = NUMB(I)
        ARP(II) = I
  110 CONTINUE
      RETURN
      END

