/*

nla-ginac - Tarjan-blocking NLA solver with autodiff
Copyright (C) 2005  John Pye

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef MC13D_H
#define MC13D_H
#include <g2c.h>

extern "C"{
	
	/// perform blocking
	int mc13d_(const unsigned *, const int *, const unsigned *, const int *, const int *
			, unsigned *ior, int *, unsigned *, int*
	);

	/// generate random number
	int fa01bs_(const int *, int *);

	/// convert to sparse form
	int setupmc13d_(const unsigned *
			, const logical *
			, const unsigned *	
			, int *
			, int *
			, const unsigned *
			, int *
	);
};

#endif
