/*

nla-ginac - Tarjan-blocking NLA solver with autodiff
Copyright (C) 2005  John Pye

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

/**
	Here are typedefs for the types of functions you need to pass to NNES
*/
namespace NNES{

	typedef void ResFn(int*overfl, const unsigned*n1, double*res, const double*y);
	typedef void Jacobian(int *overfl, const unsigned *n1, double*J, const double*y);

}

/**
	FORTRAN routines which we're linking to...
*/
extern "C"
{
	/* include this to use the symbol table */
	// #include <stdio.h>

	// #include "../compat/stuff.h"
	/* use the report() function for messages */
	//#include "../inout/report.h"

	/* Fortran nonlinear equation solver routines (NNES) */
	void setup_(int * ,int* ,int* ,int* ,int* ,
	            int* ,int* ,int* ,int* ,int* ,
	            int* ,int* ,int* ,int* ,int* ,
	            int* ,int* ,const unsigned* ,int* ,int* ,
	            int* ,int* ,int* ,int* ,int* ,
	            int* ,double* ,double* ,double* ,double* ,
	            double* ,double* ,double* ,double* ,double* ,
	            double* ,double* ,double* ,double* ,double* ,
	            double* ,double *,double *,double *,double *,
	            char *);

	void nnes_(int *ABSNEW ,int*CAUCHY ,int*DEUFLH ,int*GEOMS ,int*LINESR
				,int*NEWTON ,int*OVERCH ,int*ACPTCR ,int*ITSCLF ,int*ITSCLX
				,int*JACTYP ,int*JUPDM ,int*MAXEXP ,int*MAXIT ,int*MAXNS
				,int*MAXQNS ,int*MGLL ,int*MINQNS ,const unsigned*EQS ,int*NARMIJ
				,int*NIEJEV ,int*NJACCH ,double*NJETOT ,int*NUNIT ,int*OUTPUT
				,int*QNUPDM ,int*STOPCR ,int*SUPPRS ,int*TRMCOD ,int*TRUPDM

				,double*ALPHA ,double*CONFAC ,double*DELTA ,double*DELFAC ,double*EPSMCH
				,double*ETAFAC ,double*FCNNEW ,double*FDTOLJ ,double*FTOL ,double*LAM0
				,double*MSTPF ,double *NSTTOL,double *OMEGA,double *RATIOF,double *SIGMA

				,double*STPTOL , double*a     , double* boundl , double* boundu , double* delf
				,double*fsave  , double* ftrack , double* fvec   , double* fvecc  , double* h
				,double*hhpi   , double* jac    , double* plee   , double* rdiag  , double* s
				,double*sbar   , double* scalef , double* scalex , double* sn     , double* ssdhat
				,double*strack , double* vhat   , double* wv1    , double* wv2    , double* wv3
				,double*wv4    , double* y      , double* xplus  , double* xsave  , char* help

				,NNES::ResFn *RESFN, NNES::Jacobian *JACOBI
				/* , void (*) ,void (*) */
	          );

	double twonrm_(int *,int *,const unsigned *,double *,double *,double *);

}
/**
	END OF FORTRAN ROUTINES
*/

