/*

nla-ginac - Tarjan-blocking NLA solver with autodiff
Copyright (C) 2005  John Pye

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef PRINTBLOCKS_H
#define PRINTBLOCKS_H

#include "mc13d.h"

namespace MC13D
{
	void printrelmap(const bool *rel, const unsigned &nr, const unsigned &nc);

	void printrelmap_perm(const bool *rel, const unsigned &nr, const unsigned &nc, const unsigned *iperm);

    void printblocks(const int &n,const int &num,int *ib,const unsigned *ior,const logical *a);
	
	// print blocks on a permuted matrix:
    void printblocks_perm(const int &n,const int &num,int *ib,const unsigned *iperm,const unsigned *ior,const logical *a);
}

#endif // PRINTBLOCKS_H

