/*

nla-ginac - Tarjan-blocking NLA solver with autodiff
Copyright (C) 2005  John Pye

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef ROULETTE_H
#define ROULETTE_H

#include "solver.h"

/**
	This class will try starting the NNES solver simulation with random initial values
	and record the maximum range for each for parameter within which a convergent 
	solution has been found.
*/
class Roulette : public Solver{

private:

	const System *sys;

public:

	Roulette();

	virtual void applyLowerBound(const unsigned &i, const double &b);
	virtual void applyUpperBound(const unsigned &i, const double &b);

	virtual void visit(System *);

private:

	// vectors and arrays

	double *boundl;
	double *boundu;
};

#endif // ROULETTE_H
