/*

nla-ginac - Tarjan-blocking NLA solver with autodiff
Copyright (C) 2005  John Pye

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
#ifndef SATURATION_H
#define SATURATION_H

#include "units.h"
#include <ginac/ginac.h>

namespace Sat{
	const GiNaC::numeric T_c = 647.0960;	// critical-point temperature
	const GiNaC::numeric rho_c = 322.0;	// critical-point density / [kg/m³]

	double deltaf(const double &tau);
	double deltaftau(const double &tau);
	double deltag(const double &tau);
	double deltagtau(const double &tau);
};

#endif
