#ifndef TEARSETS_H
#define TEARSETS_H

#include <set>
#include <vector>

#include "cycle.h"

typedef std::set<unsigned> TearSet;

/**
	Given the equation-to-loops mapping, find all possible tear sets
	
	@param loops set of cycles contained in the system
	@param sets (returned) complete tearsets

	This is a home-baked algorithm and could probably be improved considerably
*/
std::vector<TearSet> tearsets(const CycleSet &loops, const unsigned &n);

#endif
