#include "tornsystem.h"

#include <iostream>

using namespace std;

TornSystem::TornSystem(){
	cerr << "TornSystem: created" << endl;
}

/**
	Analysis of the torn system requires that the 'rel' matrix be tweaked
	after its creation, to remove the relationship to the torn equations
	(torneqs) in the TearingSolver.
*/
void
TornSystem::acceptAnalyse(Solver *solver){
	cerr << "TornSystem::acceptAnalyse:..." << endl;
	SymbolicSystem::acceptAnalyse(solver);
}

void
TornSystem::acceptSolve(Solver *solver){
	cerr << "TornSystem::acceptSolve:..." << endl;
	SymbolicSystem::acceptSolve(solver);
}


void
TornSystem::defineSystem(){
	// cerr << "TornSystem::defineSystem: nothing here" << endl;
}

void
TornSystem::applySolverOptions(Solver *solver){
	OPTION(OUTPUT,0);
}

const char *
TornSystem::getType() const{
	return "TornSystem";
}

void 
TornSystem::addExpression(const GiNaC::ex &expr){
	// cerr << "TornSystem::addExpression: adding " << expr << endl;	
	SymbolicSystem::addExpression(expr);
}

void 
TornSystem::ResFn(int *overfl, const unsigned *n1, double* res, const double* y){
	//cerr << esc << "[32mTornSystem::ResFn:..." << esc << "[0m" << endl;
	//printvars(y);
	SymbolicSystem::ResFn(overfl,n1,res,y);
	//printresids(res);
	//cerr << esc << "[32;1mTornSystem::ResFn:...done" << esc << "[0m" << endl;

}

