#ifndef TORNSYSTEM_H
#define TORNSYSTEM_H

#include "symbolicsystem.h"
#include "solver.h"

/**
	A system which has had tearing variables removed from it
	is stored in this object. This means that the system can
	be solved independently by standard methods once it
	has been torn.
*/
class TornSystem : public SymbolicSystem{

public:
	TornSystem();
	virtual void acceptAnalyse(Solver *s);
	virtual void acceptSolve(Solver *s);

	const char *getType() const;
	virtual void addExpression(const GiNaC::ex &expr);
	virtual void ResFn(int *overfl, const unsigned *n1, double* res, const double* y);

private:
	void defineSystem();
	void applySolverOptions(Solver *solver);

};

#endif // TORN_SYSTEM_H
