#include "variable.h"

Variable::Variable(const char *name){
	this->name = name;
	islb=false;
	isub=false;
}

void 
Variable::setLowerBound(const double &lb){
	this->lb=lb;
	islb=true;
}

void 
Variable::setUpperBound(const double &ub){
	this->ub=ub;
	isub=true;
}

const double &
Variable::getLowerBound() const{
	return lb;
}

const double &
Variable::getUpperBound() const{
	return ub;
}

void 
Variable::setDefVal(const double &defval){
	this->defval = defval;
}

const double &
Variable::getDefVal() const{
	return defval;
}

const char *
Variable::getName() const{
	return name;
}

const bool
Variable::isBounded() const{
	return islb || isub;
}

const bool
Variable::isBoundedLower() const{
	return islb;
}

const bool
Variable::isBoundedUpper() const{
	return isub;
}
